﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid;

namespace LoadExcelFileToGrid95750
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraButton1.Click += new EventHandler(ultraButton1_Click);
        }

        void ultraButton1_Click(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            
            //Populate the DataTable with some sample data
            dt.Columns.AddRange(new DataColumn[] { new DataColumn(), new DataColumn(), new DataColumn() });
            for (int i = 0; i < 9; i++)
            {
                dt.Rows.Add("Column1Row" + i.ToString(), "Column2Row" + i.ToString(), "Column3Row" + i.ToString());
            }
            //Bind this table to the first UltraGrid
            ultraGrid1.DataSource = dt;
            ultraGrid1.DataBind();

            //Export the UltraGrid's data to an .xlsx file
            ultraGridExcelExporter1.Export(ultraGrid1, "MyExportedGrid.xlsx");

            //Load the previously generated .xlsx file
            Workbook wb = Workbook.Load("MyExportedGrid.xlsx");
            
            //Create a DataTable which will be used to store data obtained from the .xlsx file
            DataTable dt2 = new DataTable();

            //Create a variable to store the column count from the workbook's worksheet
            int colCount = 0;
            //Create an object array
            object[] rowArray;

            //Iterate thru each column within the worksheet
            foreach (WorksheetColumn column in wb.Worksheets[0].Columns)
            {
                //Add a column to the DataTable to reflect the columns present
                dt2.Columns.Add();                
                //Increment the column counter by one for each column present
                colCount++;
            }

            //Iterate thru each of the rows within the worksheet
            foreach (WorksheetRow row in wb.Worksheets[0].Rows)
            {
                //Add a row to the DataTable for each row
                dt2.Rows.Add();
                //create a new object array instance, (required to for introducing data to the DataRow)
                rowArray = new object[colCount];

                //Iterate thru each cell within the row
                foreach (WorksheetCell cell in row.Cells)
                {
                    //for each cell within the row, identified by its columnIndex, write its value to the current position in the rowArray
                    rowArray[cell.ColumnIndex] = cell.Value;
                }
                //Set current rows ItemArray to the rowArray instance that we just populated with cell data
                dt2.Rows[row.Index].ItemArray = rowArray;
            }

            dt2.Rows[0].Delete();

            ultraGrid2.DataSource = dt2;
            ultraGrid2.DataBind();
        }
    }
}
